#include <stdlib.h>   
#include <stdio.h>
#include <math.h>   
#include <e_lib.h>


int main(int argc, char *argv[])
{
  MESH *mesh;
  int  *degree, **elems;
  int   i, j, no;
  int   *nodes, *no_subdom, **subdom;


  e_GetMeshData(&mesh,"good/adj");
  e_GetDecompData(mesh,"good/adj");

  e_SetAdjacency(mesh, &degree, &elems);

  for(i = 0; i < mesh->NElemsQuad3; i++)
  {
    printf("\nElem %d:  ", i+1);
    if(degree[i] == 0)
      printf("Standing alone");
    else
      for(j = 0; j < degree[i]; j++)
        printf(" %d ", elems[i][j]);
  }
  printf("\n\n");

  e_GetInterSubDomNodes(mesh, &no, &nodes, &no_subdom, &subdom);
  printf("\nThere are %d inter-subdomain node", no);
  for(i = 0; i < no; i++)
  {
    printf("\n%d node in %d subdom which are: ", nodes[i], no_subdom[i]);
    for(j = 0; j < no_subdom[i]; j++)
      printf(" %d ", subdom[i][j]);
  }
  printf("\n\n");

}
