

int KernighanLin(int NElems, int NDummyElems, int subdomain1, int subdomain2,
                 int *Degree, int **Adjacency, int *Subdomains);
static int  SetInitialCost(int  NElems, 
                           int *Degree, int **Adjacency,
                           int  subdom1, int subdom2,
                           int *Subdomain,
                           int *NInterSubdomainElements,
                           int *InterSubdomainElements,
                           int *NetExternalCosts,
                           int *BoundMask                );
static int bound_sort_function(const void *a, const void *b);
static void UpdateBoundary(int NElems, int *Degree, int **Adjacency, 
                           int subdom1, int subdom2, int *Subdom,
                           int *NInterSubdomainElements, 
                           int *InterSubdomainElements,
                           int *NetExternalCosts,
                           int *BoundMask               );
static int SetExchangePairs(int    NElems, int NDummyElems,
                            int   *Degree, int **Adjacency, 
                            int    subdom1, int subdom2,
                            int   *Subdomain,
                            int    NInterSubdomainElements,
                            int   *InterSubdomainElements,
                            int   *NetExternalCosts,
                            int   *NExchangePairs, int **ExchangeElements,
                            int   *ExchangeGains   );
static int SetNextExchangePair(int  *Degree, int **Adjacency,
                               int  *Subdomain, int   subdom1,
                               int   NInterSubdomainElements,
                               int  *InterSubdomainElements,
                               int  *NetExternalCosts,
                               int   ExchangePairsIndex,
                               int **ExchangeElements,
                               int  *ExchangeGains             );
static int ReduceSet(int *ExchangeElements, int *NInterSubdomainElements,
                     int *InterSubdomainElements, int *NetExternalCosts  );
static int ElementsAreAdjacent(int *Degree, int **Adjacency,
                               int ElementIndex1, int ElementIndex2);


double p_rand();
int p_rnd(int low, int high);
void BoundaryShuffle(int  NInterSubdomainElements,
                     int *InterSubdomainElements,
                     int *NetExternalCosts         );













