#ifndef MEMB_ADJ_H
#define MEMB_ADJ_H_

#define ADJ_FLAT 1
#define ADJ_LINK 2

typedef struct
{
  int   *Sides;
  int  **Degree;
  int ***Adjacency;
  int ***AdjacentSide;
}
ADJDATA;


void Set2DElemAdjacency(MESH *mesh, ADJDATA **data,
                        int *no_node_elem, int **node_elem, 
                        int flag);

void e_Free2DElemAdjacency(MESH *mesh, ADJDATA *adata);

#endif


