#ifndef __DR_CALC_H__
#define __DR_CALC_H__

#include "config.h"

#include "e_lib.h"  /* MESH definition */
#include "dr.h"     /* DR_DATA definition */

#ifdef __E_MPI__
#include "mpi.h"
#include "dr_comm.h"
#endif

#ifdef __TIME_ELEM_CALC__
#include "timer.h"  /* for timing calculation */
#endif

/* globally exported functions */
int  dr_main(MESH *mesh, DR_DATA *data);
void dr_residual(MESH *mesh, DR_DATA *data);
void dr_mass(MESH *mesh, DR_DATA *data);
void dr_normal(MESH *mesh, DR_DATA *data);
void dr_pressure(MESH *mesh, DR_DATA *data);

#endif
