#ifndef __DR_COMM_DD_H__
#define __DR_COMM_DD_H__

#ifndef __E_MPI__
#error "__E_MPI__ is not defined for dr_comm_dd.h"
#endif

/* notify user about the communication type */
#define COMM_NAME "DD"

/* include the communication data structure type */
#include "comm_vector.h"

void SetupSymCommDataInit(int dimension, int NSubdomains, int i_subdom, 
                          int NInterSubDomNodes, int *InterSubDomNodes,
                          int *NNodeSubDoms, int **NodeSubDoms,
                          COMM_VECTOR_DATA **data);
void FreeSymCommDataInit(int NSubdomains, COMM_VECTOR_DATA *data);
void ConvertSymCommDataInit(MESH *mesh, COMM_VECTOR_DATA *data, 
                            int dimension);

#endif


