dnl @synopsis EG_GCOV_GCC
dnl Enable use of gcov: a Test Coverage Program in case
dnl the underlying compile is gcc by setting the flags
dnl "-fprofile-arcs -ftest-coverage". This macro will add
dnl them to $CFLAGS and $CXXFLAGS if $CC is found to be a gcc.
dnl
dnl Modeled after PETI_PEDANTIC_GCC by Peter Simons.
dnl @author Roman Putanowicz <putanowr@twins.pk.edu.pl>
dnl @version $Id: eg_gcov_gcc.m4,v 1.1 2002/08/06 11:23:23 romek Exp $ 
AC_DEFUN([EG_GCOV_GCC],
    [
    if test "$GCC" = yes; then
        CFLAGS="$CFLAGS -fprofile-arcs -ftest-coverage"
        CXXFLAGS="$CXXFLAGS -fprofile-arcs -ftest-coverage"
        fi
    ])
