


#ifdef  JJJ_MAIN
#define X_MAIN
#endif
#ifndef JJJ_MAIN

#define X_MAIN  extern
#endif

                          /* max. lenght of a filename string              */
#define MAXFILENAME   512
#define MAXFILETITLE  30


char szAppName[]        = "E_PLOT32";
char szEnWindowTitle[]  = "E_Plot32";
char *szEmfFilter[] = { "Enhanced Windows Metafile (*.emf)", "*.emf", "Windows Metafile (*.wmf)", "*.wmf", "All Files (*.*)", "*.*", "" } ;

HANDLE G_hInst;

HANDLE hDevMode = NULL;
HANDLE hDevNames = NULL;

HANDLE G_main_hwnd;

OPENFILENAME ofn;


long FAR PASCAL _export j_main_wndproc(HWND j_hwnd, UINT J_uint1, UINT J_uint2, LONG j_long);

int w_OkMsgBox(char *szFmt, ...);
int w_OkCancelMsgBox(char *szFmt, ...);
int w_OkCancelStopMsgBox(char *szFmt, ...);
int w_OkStopMsgBox(char *szFmt, ...);
void j_FileInitialize(HWND hwnd);
BOOL j_FileOpenDlg(HWND hwnd, LPSTR lpstrFileName, LPSTR lpstrTitleName);
void j_DoCaption(HWND hwnd, char *szTitleName);
BOOL j_FileSaveDlg (HWND hwnd, LPSTR lpstrFileName, LPSTR lpstrTitleName);
BOOL j_FileSaveImage(HWND hwndEdit, LPSTR lpstrFileName);
BOOL FAR PASCAL _export AboutEplotDlgProc(HWND hDlg,UINT message,UINT wParam,LONG lParam);
BOOL FAR PASCAL _export SpSelDlgProc(HWND hDlg,UINT message,UINT wParam,LONG lParam);
BOOL FAR PASCAL _export ZoomToDlgProc(HWND hDlg, UINT message, UINT wParam, LONG lParam);
BOOL FAR PASCAL _export GIDlgProc(HWND hDlg, UINT message, UINT wParam, LONG lParam);

void    j_init_perspective(void);
double  j_getmaxmeshparam(void);
double  j_getmaxsidelength(POLYGON *polygons, int Npoly);
double  j_getminsidelength(POLYGON *polygons, int Npoly);
double  j_getmaxerror(void);
void    j_setup_stresspoints(void);
void    j_getmaxstresses(void);
#define j_sqx(x)  pow(x,2)
double  j_getlength(int p1, int p2);

void 	j_zoom_to_node(int n);

void j_sort_polygons(int *order,POLYGON *polygons,int Npoly);
int j_compare_polygons(const void *i, const void *j);
int j_do_projection(POLYGON *polygons, int NPoly);

double	j_getavsl(j_3Dvector node1, j_3Dvector node2);

void Create_Subdomain_Graph(MESH *mesh,
                            int *SubdomGraphDegree, int **SubdomGraph,
                            int **SubdomGraphRef);


int x_screen_size,y_screen_size,
    w_xmclient_size,w_ymclient_size;

#define MAX_ASSUMED_SUBDOMS_FOR_COLOURS  16

DWORD wSubdomColours[MAX_ASSUMED_SUBDOMS_FOR_COLOURS];
DWORD wSubdomBWColours[MAX_ASSUMED_SUBDOMS_FOR_COLOURS];
DWORD wSubdom4Col[6];


HDC GetCurrentPrinterDC (void);
BOOL FAR PASCAL _export AbortProc (HDC hdcPrn, short nCode);
BOOL j_print_page(HWND hwnd);

void   j_Det4Cols(int *wSD4Cols, int **wSDGraph, int nsd);
void   j_paint_screen_elems(HDC hdc, int wmfexp);
void   j_draw_segment(HDC hdc, j_3Dvector vf, j_3Dvector vt);
void   j_paintsimple_3Dfigure(HDC hdc,WORD wSelection);
void   j_drawscale(HDC hdc);
double j_col_scale(double x,double zeta);
void   j_drawZetascale(HDC hdc);


                                  /* string variable for the project name  */
                                  /* without ".extension"                  */
X_MAIN char G_file[MAXFILENAME];

                                  /* string for the file title (no ".ext") */
X_MAIN char G_filetitle[MAXFILETITLE];


X_MAIN char G_wmf_file[MAXFILENAME];



MESH *fem1;
POLYGON	*pg;

X_MAIN j_3Dvector OO,OX,OY,OZ;
X_MAIN j_3Dvector SO,SX,SY,SZ;


#define ELEMENT_SIZE   1.00

        /* the rect to fit the whole structure in */
X_MAIN double w_dGlobCoordL,
              w_dGlobCoordR,
              w_dGlobCoordT,
              w_dGlobCoordB,
              w_dGlobCoordU,
              w_dGlobCoordD;
X_MAIN double w_maxsize;
X_MAIN double w_maxmeshparam;
X_MAIN double w_maxsidelength;
X_MAIN double w_maxerror;
X_MAIN double w_maxXstress,w_maxYstress,w_maxXYstress;
X_MAIN int    w_iWhichStress;
X_MAIN int	  w_iWhichStressPoint[E_NELEM_TYPES];
X_MAIN int	  w_iWhichLayer;
X_MAIN int    w_iBW_subdomains;
X_MAIN BOOL   w_iSB;
X_MAIN double w_maxStress_percent;
X_MAIN double w_Element_Size_percent;
X_MAIN double w_Link_Size_percent;
X_MAIN BOOL   wDisplElemNo,wDisplPointNo,wTileElems,wTileLinks,wDisplScale;
X_MAIN BOOL	  wHidden,wPrintPrev,wAdvHidden;
X_MAIN BOOL   wPlotSelect;
X_MAIN BOOL	  wClipPlane;
X_MAIN BOOL	  w4Col;
X_MAIN int	 *wSD4Cols;
X_MAIN int   *wSDGrDeg;
X_MAIN int  **wSDGraph;
X_MAIN int  **wSDGrRef;

POLYGON 	*polygons;
int			Npoly;

int j_OK;

         /* coefficient for colour enhancement  */
X_MAIN double wZeta;
        /* and its initial value  */
#define INIT_ZETA     0.00

        /*  displacement magnification factor  */
X_MAIN double w_displmag;
        /* and its initial value  */
#define INIT_DISP_MAGN  10.00e+01


#define INIT_AZIMUTH    -72.00
#define INIT_ELEVATION   27.00


/* For the mouse controll:  */
          /*   degree / num. of pixel (in mouse movement)  */
#define j3D_AZIMUTH_INCREMENT       5.00 / 10.00
#define j3D_ELEVATION_INCREMENT     5.00 / 10.00
          /*  percent / num. of pixel (in mouse movement)  */
#define j3D_DISTANCE_MULTIPLIER     5.00 / 20.00
#define j3D_SCALEFACT_MULTIPLIER    5.00 / 20.00
#define j3D_DISPLMAG_MULTIPLIER    15.00 / 20.00
#define j3D_STRESSCOL_PC_INCREMENT  1.00 /  5.00
#define j3D_ZETA_INCREMENT          0.02 / 10.00

/*
     Memory considerations for polypolygon() function
     ================================================


POINT           ------>  4 bytes
    {
    int x;
    int y;
    }

We can allocate 2^16 byte memory

TRIANG needs 4 POINT structures  =  16 bytes
QUAD   needs 5 POINT structures  =  20 bytes

2^16 / 16 = 2^12        =  4096     triangles
2^16 / 20 =             =  3276.8   quadrilaterals
                       ===============
These are the max number of polygons we can display
with a polypolygon function.  Thus:

A trial to use the Polypolygon() function to draw the mesh is
in the file e_plot.tr1

It did not work for big meshes (NE>5000)


*/

#define MAX_NUM_TRIANG_FOR_POLYPOLY 4000
#define MAX_NUM_QUAD_FOR_POLYPOLY   3000







#define E_ICON	220



#define MAIN_MENU	          100

#define NUM_PLOT_OPTION_POPUP  3

#define IDM_PO_PLAINMESH      40
#define IDM_PO_SUBDOMAIN      41
#define IDM_PO_MESHPARAM      42
#define IDM_PO_STRESS         43
#define IDM_PO_ERROR          44

#define IDM_POO_XXSTRESS      50
#define IDM_POO_YYSTRESS      51
#define IDM_POO_XYSTRESS      52

#define IDM_POO_SD_BW         53
#define IDM_POO_SB            54
#define IDM_POO_SP_SEL		  55
#define IDM_POO_4COL		  56

#define IDM_D_TILE_LINKS	  35
#define IDM_D_TILE_ELEMS	  34
#define IDM_D_DISPLSCALE      33
#define IDM_D_POINT_NO	      32
#define IDM_D_ELEM_NO	      31
#define IDM_D_SAVE_IMAGE	  30
#define IDM_D_CLIP            36


#define IDM_F_OPEN	          11
#define IDM_F_CLOSE	          12
#define IDM_F_ABOUT	          14
#define IDM_F_EXIT	          13
#define IDM_F_PRINT			  15
#define IDM_F_PSU			  16
#define IDM_F_PPREV			  17

#define IDM_H_CONT		21
#define IDM_H_SEARCH		22
#define IDM_H_HOW		23
#define IDM_H_DEBUG		24


#define IDM_P_AZIM_ELEV       151
#define IDM_P_TCDIST_SCALE    152
#define IDM_P_SCRORIGIN       153
#define IDM_P_TARGETCOORDS    154
#define IDM_P_TARGETELEV	  155

#define IDM_P_STRESSCOL	      156
#define IDM_P_ZETAADJUST      158


#define IDM_P_PLAN_VIEW	      159
#define IDM_P_NICE_VIEW	      160
#define IDM_P_HID_VIEW		  161
#define IDM_P_ABOUT           162
#define IDM_P_ZOOM_TO         163
#define IDM_P_ADV_HID_VIEW	  164
#define IDM_P_GRAPHICSINFO	  165

#define IDD_SP_SEL	1
#define IDD_ZOOMTO	2
#define IDD_GRAPHICS_INFO 3

#define IDC_LINK1	101
#define IDC_LINK5	105
#define IDC_TETRAH1	112
#define IDC_UD_LINK5	118
#define IDC_UD_LINK4	117
#define IDC_UD_LINK3	116
#define IDC_UD_LINK2	113
#define IDC_UD_LINK1	114
#define IDC_UD_TRIANG1	115
#define IDC_UD_TRIANG2	119
#define IDC_UD_TRIANG3	120
#define IDC_UD_TRIANG4	121
#define IDC_UD_TRIANG5	122
#define IDC_UD_QUAD1	123
#define IDC_UD_TETRAH1	124
#define IDC_QUAD1	111
#define IDC_TRIANG5	110
#define IDC_TRIANG3	108
#define IDC_TRIANG4	109
#define IDC_TRIANG8	108
#define IDC_TRIANG2	107
#define IDC_TRIANG1	106
#define IDC_LINK4	104
#define IDC_LINK3	103
#define IDC_LINK2	102

#define IDC_NODE 201
#define IDC_UD_NODE 202
#define IDC_ZT_NODE 203

#define IDC_GI_APPLY 	301
#define IDC_GI_AZIM  	302
#define IDC_GI_ELEV		303
#define IDC_GI_DTC		304
#define IDC_GI_SCALE	305
#define IDC_GI_TARGETX	306
#define IDC_GI_TARGETY	307
#define IDC_GI_TARGETZ	308
#define IDC_GI_PLAN		309
#define IDC_GI_NICE		310

          /* Colours being used */
#define WHITE  RGB(0xFF,0xFF,0xFF)
#define BLACK  RGB(0x00,0x00,0x00)
#define RED    RGB(0xFF,0x00,0x00)
#define BLUE   RGB(0x00,0x00,0xFF)
#define GREEN  RGB(0x00,0xFF,0x00)
#define YELLOW RGB(0xFF,0xFF,0x00)

#define SKY_BLUE      RGB(0x00,0xCC,0xFF)
#define LIGHT_ORANGE  RGB(0xFF,0x99,0x33)
#define SPRING_GREEN  RGB(0x33,0xCC,0x33)
#define BROWN         RGB(0x99,0x66,0x33)
#define DARK_GRAY     RGB(0x66,0x66,0x66)
#define LIGHT_GRAY    RGB(0x99,0x99,0x99)
#define MIDDLE_GRAY   RGB(0x80,0x80,0x80)
#define MAGENTA       RGB(0xFF,0x00,0xFF)


         /*  Dark Gray  */
#define SD_No1   RGB( 90, 90, 90)
         /*  Red  */
#define SD_No2   RGB(255, 82,  8)
         /*  Blue  */
#define SD_No3   RGB(  8, 82,255)
         /*  Cyan  */
#define SD_No4   RGB(  8,255,255)
         /*  Orange  */
#define SD_No5   RGB(255,173,  8)
         /*  Magenta  */
#define SD_No6   RGB(255,  8,173)
         /*  Brown  */
#define SD_No7   RGB(140,123, 82)
         /*  Green  */
#define SD_No8   RGB( 82,255,  8)


#define SD_BW_No1   RGB(253,253,253)
#define SD_BW_No2   RGB(172,172,172)
#define SD_BW_No3   RGB(222,222,222)
#define SD_BW_No4   RGB(102,102,102)
#define SD_BW_No5   RGB(240,240,240)
#define SD_BW_No6   RGB(200,200,200)
#define SD_BW_No7   RGB(139,139,139)
#define SD_BW_No8   RGB( 60, 60, 60)

#define SD_4COL_1   RGB(209,  1,  1)
#define SD_4COL_2   RGB(255,212, 60)
#define SD_4COL_3   RGB( 42, 33,234)
#define SD_4COL_4	RGB( 34,123, 20)
#define SD_4COL_5	RGB( 80, 80, 80)
#define SD_4COL_6	RGB(255,255,255)

#define MP_R_MAX  0x00
#define MP_G_MAX  0xFF
#define MP_B_MAX  0x00

#define ER_R_MAX  0xFF
#define ER_G_MAX  0x00
#define ER_B_MAX  0x00





              /* GREEN     */
#define STE_XX_POS_R_MAX 0x00
#define STE_XX_POS_G_MAX 0xFF
#define STE_XX_POS_B_MAX 0x5A
              /* RED       */
#define STE_XX_NEG_R_MAX 0xFF
#define STE_XX_NEG_G_MAX 0x00
#define STE_XX_NEG_B_MAX 0x6A

              /* PURPLE    */
#define STE_YY_POS_R_MAX 0xB4
#define STE_YY_POS_G_MAX 0x00
#define STE_YY_POS_B_MAX 0xFF
              /* YELLOW    */
#define STE_YY_NEG_R_MAX 0xFF
#define STE_YY_NEG_G_MAX 0xFF
#define STE_YY_NEG_B_MAX 0x00

              /* CYAN      */
#define STE_XY_POS_R_MAX 0x00
#define STE_XY_POS_G_MAX 0xD4
#define STE_XY_POS_B_MAX 0xFF
              /* ORANGE    */
#define STE_XY_NEG_R_MAX 0xFF
#define STE_XY_NEG_G_MAX 0x64
#define STE_XY_NEG_B_MAX 0x00

#define SUBDOMCOLS 16
int subdomcolors[SUBDOMCOLS][3] =
{
  {209,  1,  1},
  {255,212, 60},
  { 42, 33,234},
  { 34,123, 20},
  { 80, 80, 80},
  {188, 15,171},
  {206, 75, 14},
  { 13,232,217},
  {164,232, 30},
  {188,188,188},
  {255,112,112},
  {  0,  8, 86},
  {255,106,  0},
  { 93,255,  0},
  {255,  0,140},
  {255,255,255}
};


